/*
	**************************************************************************
	(C) 2012. IntBuSoft Ltd. http://intbusoft.com
	main.cpp - Test AztecMarker
	**************************************************************************
	Programer: Kruchinin Aleksandr.
	**************************************************************************
	May be used under the terms of the GNU Lesser General Public License (LGPL)   

*/
#include "adcoding.h"
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

#ifndef DWORD
typedef unsigned long DWORD;
#endif

#ifndef WORD
typedef unsigned short WORD;
#endif

#ifndef LONG
typedef long LONG;
#endif


int main(int argc, char** argv)
{
	// Sample Encode/Decode
/*	unsigned char c=210;
	bool m[121];
	EncodeAM(c,m);
	int i,j;
	for(i=0;i<11;i++)
	{
		for(j=0;j<11;j++)
		{
			printf("%d",m[j+i*11]);
		}
		printf("\n");
	}	
	unsigned char o;
	int err=DecodeAM(m,&o);*/
	
	//Console Encode to 1bit image
	if (argc<3) {
		printf("(C) 2012. IntBuSoft Ltd. Aztec Marker Encode Decode. http://intbusoft.com\n AztecMarker <code symbol> <filename>");
		return 1;
	}
	bool m[121];
	unsigned char c=atoi(argv[1]);	
	EncodeAM(c,m);
	int i,j;
	for(i=0;i<11;i++)
	{
		for(j=0;j<11;j++)
		{
			printf("%d",m[j+i*11]);
		}
		printf("\n");
	}	

	// 
	FILE *f;
	f=fopen(argv[2],"wb");
	fputs("BM",f);	
    WORD    bfReserved1=0;
    WORD    bfReserved2=0;
    DWORD   bfOffBits=62;
	DWORD   biSize=40;
	LONG	biWidth=13;
	LONG	biHeight=13;
	WORD	biPlanes=1;
	WORD	biBitCount=1;
	DWORD	biCompression=0;
	DWORD	biSizeImage=4*13;
	LONG	biXPelsPerMeter=0;
	LONG	biYPelsPerMeter=0; 
	DWORD	biClrUsed=0;
	DWORD	biClrImportant=0;
	DWORD   bfSize=bfOffBits+biSizeImage;
	fwrite(&bfSize,1,4,f);
	fwrite(&bfReserved1,1,2,f);
	fwrite(&bfReserved2,1,2,f);
	fwrite(&bfOffBits,1,4,f);
	fwrite(&biSize,1,4,f);
	fwrite(&biWidth,1,4,f);
	fwrite(&biHeight,1,4,f);
	fwrite(&biPlanes,1,2,f);
	fwrite(&biBitCount,1,2,f);
	fwrite(&biCompression,1,4,f);
	fwrite(&biSizeImage,1,4,f);
	fwrite(&biXPelsPerMeter,1,4,f);
	fwrite(&biYPelsPerMeter,1,4,f);
	fwrite(&biClrUsed,1,4,f);
	fwrite(&biClrImportant,1,4,f);
	unsigned char bb[8]={
		0,0,0,0,255,255,255,0
	};
	fwrite(bb,1,8,f);
	unsigned char *buf=new unsigned char [4*13];
	memset((void*)buf,255,4*13);	
	for(i=1;i<12;i++)		
		for(j=1;j<12;j++)
		{
			buf[i*4+int(j/8)]-= (1 << (7-(j%8)))*m[j-1+(11-i)*11];
		}
	fwrite(buf,1,biSizeImage,f);
	fclose(f);
	delete buf;
	return 0;
}